var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { BaseWidget, SplitPanel, Widget } from '@theia/core/lib/browser';
import { Emitter, ILogger } from '@theia/core/lib/common';
import { WorkspaceService } from '@theia/workspace/lib/browser/workspace-service';
import { injectable, postConstruct } from 'inversify';
import { debounce, isEqual } from 'lodash';
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import { JSONFormsWidget } from './json-forms-widget';
import { JsonFormsTreeWidget } from './tree-widget';
var JsonFormsTreeEditorWidget = /** @class */ (function (_super) {
    __extends(JsonFormsTreeEditorWidget, _super);
    function JsonFormsTreeEditorWidget(treeWidget, formWidget, workspaceService, logger, widget_id) {
        var _this = _super.call(this) || this;
        _this.treeWidget = treeWidget;
        _this.formWidget = formWidget;
        _this.workspaceService = workspaceService;
        _this.logger = logger;
        _this.widget_id = widget_id;
        _this.dirty = false;
        _this.onDirtyChangedEmitter = new Emitter();
        _this.id = widget_id;
        _this.splitPanel = new SplitPanel();
        _this.addClass('json-forms-tree-editor');
        _this.splitPanel.addClass('json-forms-tree-editor-sash');
        _this.treeWidget.addClass('json-forms-tree-editor-tree');
        _this.formWidget.addClass('json-forms-tree-editor-forms');
        _this.formWidget.onChange(debounce(function (data) {
            if (!_this.selectedNode ||
                !_this.selectedNode.jsonforms ||
                isEqual(_this.selectedNode.jsonforms.data, data)) {
                return;
            }
            _this.handleFormUpdate(data, _this.selectedNode);
        }, 250));
        _this.toDispose.push(_this.treeWidget.onSelectionChange(function (ev) { return _this.treeSelectionChanged(ev); }));
        _this.toDispose.push(_this.treeWidget.onDelete(function (node) { return _this.deleteNode(node); }));
        _this.toDispose.push(_this.treeWidget.onAdd(function (addProp) { return _this.addNode(addProp); }));
        _this.toDispose.push(_this.onDirtyChangedEmitter);
        return _this;
    }
    Object.defineProperty(JsonFormsTreeEditorWidget.prototype, "onDirtyChanged", {
        get: function () {
            return this.onDirtyChangedEmitter.event;
        },
        enumerable: true,
        configurable: true
    });
    JsonFormsTreeEditorWidget.prototype.init = function () {
        this.configureTitle(this.title);
    };
    JsonFormsTreeEditorWidget.prototype.onResize = function (_msg) {
        if (this.splitPanel) {
            this.splitPanel.update();
        }
    };
    JsonFormsTreeEditorWidget.prototype.renderError = function (errorMessage) {
        ReactDOM.render(React.createElement(React.Fragment, null, errorMessage), this.formWidget.node);
    };
    JsonFormsTreeEditorWidget.prototype.treeSelectionChanged = function (selectedNodes) {
        if (selectedNodes.length === 0) {
            this.selectedNode = undefined;
        }
        else {
            this.selectedNode = selectedNodes[0];
            this.formWidget.setSelection(this.selectedNode);
        }
        this.update();
    };
    JsonFormsTreeEditorWidget.prototype.onAfterAttach = function (msg) {
        this.splitPanel.addWidget(this.treeWidget);
        this.splitPanel.addWidget(this.formWidget);
        this.splitPanel.setRelativeSizes([1, 4]);
        Widget.attach(this.splitPanel, this.node);
        this.treeWidget.activate();
        _super.prototype.onAfterAttach.call(this, msg);
    };
    JsonFormsTreeEditorWidget.prototype.onActivateRequest = function () {
        if (this.splitPanel) {
            this.splitPanel.node.focus();
        }
    };
    JsonFormsTreeEditorWidget.prototype.save = function () {
        // do nothing by default
    };
    __decorate([
        postConstruct(),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], JsonFormsTreeEditorWidget.prototype, "init", null);
    JsonFormsTreeEditorWidget = __decorate([
        injectable(),
        __metadata("design:paramtypes", [JsonFormsTreeWidget,
            JSONFormsWidget,
            WorkspaceService, Object, String])
    ], JsonFormsTreeEditorWidget);
    return JsonFormsTreeEditorWidget;
}(BaseWidget));
export { JsonFormsTreeEditorWidget };
(function (JsonFormsTreeEditorWidget) {
    JsonFormsTreeEditorWidget.WIDGET_LABEL = 'JSONForms Tree Editor';
    var Styles;
    (function (Styles) {
        Styles.JSONFORMS_TREE_EDITOR_CLASS = 'json-forms-tree-editor';
    })(Styles = JsonFormsTreeEditorWidget.Styles || (JsonFormsTreeEditorWidget.Styles = {}));
})(JsonFormsTreeEditorWidget || (JsonFormsTreeEditorWidget = {}));
//# sourceMappingURL=tree-editor-widget.js.map